
-- Updated by Speed
-- Updated by Michh_EU

	global ostream, tabs = ""
	global isFileSCM = false
	global isFileSCN = false
	
	rollout ATMDef "Atmo/Light/Camera" rolledUp
	(		
		group "Definicja atmosfery"
		(
--	 atmosphere definition
			label labA "Atmo color"
			spinner spnAtmoR "R" range:[0.00,1.00,0.60] scale:0.01 type:#float fieldwidth:35 across:3
			spinner spnAtmoG "G" range:[0.00,1.00,0.70] scale:0.01 type:#float fieldwidth:35
			spinner spnAtmoB "B" range:[0.00,1.00,0.80] scale:0.01 type:#float fieldwidth:35
			label labB "Fog color"
			spinner spnFogR "R" range:[0.00,1.00,0.60] scale:0.01 type:#float fieldwidth:35 across:3
			spinner spnFogG "G" range:[0.00,1.00,0.70] scale:0.01 type:#float fieldwidth:35
			spinner spnFogB "B" range:[0.00,1.00,0.80] scale:0.01 type:#float fieldwidth:35
			label labC "Fog distance"
			spinner spnFogBeg "Begin" range:[0,10000,300] type:#integer fieldwidth:50 across:2
			spinner spnFogEnd "End" range:[0,10000,1600] type:#integer fieldwidth:50
		)		
		group "Definicja owietlenia"
		(
--	 light definition		
			label labD "Pozycja owietlenia"
			spinner spnLPosX "X" range:[-10000,10000,-500] type:#integer fieldwidth:50 across:3
			spinner spnLPosY "Y" range:[-10000,10000,500] type:#integer fieldwidth:50
			spinner spnLPosZ "Z" range:[-10000,10000,200] type:#integer fieldwidth:50
			label labE "Ambient"
			spinner spnLAmbR "R" range:[0.00,1.00,0.30] scale:0.01 type:#float fieldwidth:35 across:3
			spinner spnLAmbG "G" range:[0.00,1.00,0.33] scale:0.01 type:#float fieldwidth:35
			spinner spnLAmbB "B" range:[0.00,1.00,0.35] scale:0.01 type:#float fieldwidth:35
			label labF "Diffuse"
			spinner spnLDifR "R" range:[0.00,1.00,0.70] scale:0.01 type:#float fieldwidth:35 across:3
			spinner spnLDifG "G" range:[0.00,1.00,0.65] scale:0.01 type:#float fieldwidth:35
			spinner spnLDifB "B" range:[0.00,1.00,0.60] scale:0.01 type:#float fieldwidth:35
			label labG "Specular"
			spinner spnLSpecR "R" range:[0.00,1.00,0.75] scale:0.01 type:#float fieldwidth:35 across:3
			spinner spnLSpecG "G" range:[0.00,1.00,0.74] scale:0.01 type:#float fieldwidth:35
			spinner spnLSpecB "B" range:[0.00,1.00,0.70] scale:0.01 type:#float fieldwidth:35
		)	
		group "Definicja kamery"
		(
--	 camera definition		
			label labH "Pozycja"
			spinner spnCPosX "X" range:[-20000,20000,-10] type:#integer fieldwidth:50 across:3
			spinner spnCPosY "Y" range:[-20000,20000,4] type:#integer fieldwidth:50
			spinner spnCPosZ "Z" range:[-20000,20000,80] type:#integer fieldwidth:50
			label labJ "Spot"
			spinner spnCVecR "X" range:[-20000,20000,0] type:#integer fieldwidth:50 across:3
			spinner spnCVecG "Y" range:[-20000,20000,0] type:#integer fieldwidth:50
			spinner spnCVecB "Z" range:[-20000,20000,0] type:#integer fieldwidth:50
		)	
		------------------------------------------------------------------------------------------------		
		function ExportATMDefs =
		(
			Format ("atmo % % %  % %  % % % endatmo\n") spnAtmoR.value spnAtmoG.value spnAtmoB.value spnFogBeg.value spnFogEnd.value spnFogR.value spnFogG.value spnFogB.value to:ostream
			Format ("light % % %  % % %  % % %  % % % endlight\n") spnLPosX.value spnLPosY.value spnLPosZ.value spnLAmbR.value spnLAmbG.value spnLAmbB.value spnLDifR.value spnLDifG.value spnLDifB.value spnLSpecR.value spnLSpecG.value spnLSpecB.value to:ostream
			Format ("camera % % %  % % % endcamera\n\n") spnAtmoR.value spnAtmoG.value spnAtmoB.value spnFogBeg.value spnFogEnd.value spnFogR.value spnFogG.value spnFogB.value to:ostream
		)
	)
		------------------------------------------------------------------------------------------------
	rollout ttttrainset "Polozenia pociagu" rolledUp
	(	
		group "Definicja polozenia pociagu"
		(
		 editText eNametr "Name" text:"none" 
	     editText etraktr "tor" text:"tor1"
		 editText edisttr "distance" text:"0.0"
	     editText eveltr "Vel" text:"0.0"
		)		
		group "Dynamic1 Definition"
		(
		 edittext eMaxdist "Maxdist" text:"-1"
		 edittext eMindist "mindist" text:"0"
	     edittext eNametrr "Nazwa" text:"EU07-485"   
	     edittext eDirtrr "Dir" text:"PKP\EU07"
         button texturelok "Wybierz texture"
	     edittext eTextrr23 "Tex"
	     button chklok "Wybierz Chk"
		 edittext eChktrr23 "Chk"
	     edittext eXxxtrr "Dist" text:"0.0"  
	     edittext eDrvtrr "Drv" text:"headdriver"  
	     edittext eSprtrr "Sprz" text:"3"    
	     edittext eSpztrr "L" text:"0"    
		)
	    group "Dynamic2 Definition"
		(
		 checkbox cb_Trainset2 "Add dynamic"   
		 edittext eMaxdist2 "Maxdist" text:"-1"
		 edittext eMindist2 "mindist" text:"0"
	     edittext eNametrr2 "Nazwa" text:"505120-00351-4"   
	     edittext eDirtrr2 "Dir" text:"PKP\Adu"    
	     edittext eTextrr2 "Tex" text:"#1klasa1.tga"   
	     edittext eChktrr2 "Chk" text:"112a" 
	     edittext eXxxtrr2 "Dist" text:"0.0"  
	     edittext eDrvtrr2 "Drv" text:"nobody"  
	     edittext eSprtrr2 "Sprz" text:"3"    
	     edittext eSpztrr2 "L" text:"0"    
		)
        group "Dynamic3 Definition"
		(
		 checkbox cb_Trainset3 "Add dynamic"   
		 edittext eMaxdist3 "Maxdist" text:"-1"
		 edittext eMindist3 "mindist" text:"0"
	     edittext eNametrr3 "Nazwa" text:"505120-00351-4"   
	     edittext eDirtrr3 "Dir" text:"PKP\Adu"    
	     edittext eTextrr3 "Tex" text:"#1klasa1.tga"   
	     edittext eChktrr3 "Chk" text:"112a" 
	     edittext eXxxtrr3 "Dist" text:"0.0"  
	     edittext eDrvtrr3 "Drv" text:"nobody"  
	     edittext eSprtrr3 "Sprz" text:"3"    
	     edittext eSpztrr3 "L" text:"0"    
		)
        group "Dynamic4 Definition"
		(
		 checkbox cb_Trainset4 "Add dynamic"   
		 edittext eMaxdist4 "Maxdist" text:"-1"
		 edittext eMindist4 "mindist" text:"0"
	     edittext eNametrr4 "Nazwa" text:"505120-00351-4"   
	     edittext eDirtrr4 "Dir" text:"PKP\Adu"    
	     edittext eTextrr4 "Tex" text:"#1klasa1.tga"   
	     edittext eChktrr4 "Chk" text:"112a" 
	     edittext eXxxtrr4 "Dist" text:"0.0"  
	     edittext eDrvtrr4 "Drv" text:"nobody"  
	     edittext eSprtrr4 "Sprz" text:"3"    
	     edittext eSpztrr4 "L" text:"0"    
		)
        group "Dynamic5 Definition"
		(
		 checkbox cb_Trainset5 "Add dynamic"   
		 edittext eMaxdist5 "Maxdist" text:"-1"
		 edittext eMindist5 "mindist" text:"0"
	     edittext eNametrr5 "Nazwa" text:"505120-00351-4"   
	     edittext eDirtrr5 "Dir" text:"PKP\Adu"    
	     edittext eTextrr5 "Tex" text:"#1klasa1.tga"   
	     edittext eChktrr5 "Chk" text:"112a" 
	     edittext eXxxtrr5 "Dist" text:"0.0"  
	     edittext eDrvtrr5 "Drv" text:"nobody"  
	     edittext eSprtrr5 "Sprz" text:"3"    
	     edittext eSpztrr5 "L" text:"0"    
		)
        group "Dynamic6 Definition"
		(
		 checkbox cb_Trainset6 "Add dynamic"   
		 edittext eMaxdist6 "Maxdist" text:"-1"
		 edittext eMindist6 "mindist" text:"0"
	     edittext eNametrr6 "Nazwa" text:"505120-00351-4"   
	     edittext eDirtrr6 "Dir" text:"PKP\Adu"    
	     edittext eTextrr6 "Tex" text:"#1klasa1.tga"   
	     edittext eChktrr6 "Chk" text:"112a" 
	     edittext eXxxtrr6 "Dist" text:"0.0"  
	     edittext eDrvtrr6 "Drv" text:"nobody"  
	     edittext eSprtrr6 "Sprz" text:"3"    
	     edittext eSpztrr6 "L" text:"0"    
		)
        group "Dynamic7 Definition"
		(
		 checkbox cb_Trainset7 "Add dynamic"   
		 edittext eMaxdist7 "Maxdist" text:"-1"
		 edittext eMindist7 "mindist" text:"0"
	     edittext eNametrr7 "Nazwa" text:"505120-00351-4"   
	     edittext eDirtrr7 "Dir" text:"PKP\Adu"    
	     edittext eTextrr7 "Tex" text:"#1klasa1.tga"   
	     edittext eChktrr7 "Chk" text:"112a" 
	     edittext eXxxtrr7 "Dist" text:"0.0"  
	     edittext eDrvtrr7 "Drv" text:"nobody"  
	     edittext eSprtrr7 "Sprz" text:"3"    
	     edittext eSpztrr7 "L" text:"0"    
		)
        group "Dynamic8 Definition"
		(
		 checkbox cb_Trainset8 "Add dynamic"   
		 edittext eMaxdist8 "Maxdist" text:"-1"
		 edittext eMindist8 "mindist" text:"0"
	     edittext eNametrr8 "Nazwa" text:"505120-00351-4"   
	     edittext eDirtrr8 "Dir" text:"PKP\Adu"    
	     edittext eTextrr8 "Tex" text:"#1klasa1.tga"   
	     edittext eChktrr8 "Chk" text:"112a" 
	     edittext eXxxtrr8 "Dist" text:"0.0"  


	     edittext eDrvtrr8 "Drv" text:"nobody"  
	     edittext eSprtrr8 "Sprz" text:"3"    
	     edittext eSpztrr8 "L" text:"0"    
		)
        group "Dynamic9 Definition"
		(
		 checkbox cb_Trainset9 "Add dynamic"   
		 edittext eMaxdist9 "Maxdist" text:"-1"
		 edittext eMindist9 "mindist" text:"0"
	     edittext eNametrr9 "Nazwa" text:"505120-00351-4"   
	     edittext eDirtrr9 "Dir" text:"PKP\Adu"    
	     edittext eTextrr9 "Tex" text:"#1klasa1.tga"   
	     edittext eChktrr9 "Chk" text:"112a" 
	     edittext eXxxtrr9 "Dist" text:"0.0"  
	     edittext eDrvtrr9 "Drv" text:"nobody"  
	     edittext eSprtrr9 "Sprz" text:"3"    
	     edittext eSpztrr9 "L" text:"0"    
		)
        group "Dynamic10 Definition"
		(
		 checkbox cb_Trainset10 "Add dynamic"   
		 edittext eMaxdist10 "Maxdist" text:"-1"
		 edittext eMindist10 "mindist" text:"0"
	     edittext eNametrr10 "Nazwa" text:"505120-00351-4"   
	     edittext eDirtrr10 "Dir" text:"PKP\Adu"    
	     edittext eTextrr10 "Tex" text:"#1klasa1.tga"   
	     edittext eChktrr10 "Chk" text:"112a" 
	     edittext eXxxtrr10 "Dist" text:"0.0"  
	     edittext eDrvtrr10 "Drv" text:"nobody"  
	     edittext eSprtrr10 "Sprz" text:"3"    
	     edittext eSpztrr10 "L" text:"0"    
		)

		group "Endtrainset Definition"
		(
		 edittext eNdtrainset "END" text:"endtrainset"   
 		)
		group ""
		(
		 label a1 "Export Trainset Definitions"
		 label a2 "Created by Michh_EU"
		 label a3 "michh@tlen.pl"
		 label a4 "Tlumaczenie pol102"
		)
		------------------------------------------------------------------------------------------------		
			function ExportTrainset =
			(	        
			  Format ("trainset % % % %\n") eNametr.text etraktr.text edisttr.text eveltr.text to:ostream
			  
			  Format ("node % % % dynamic % % % % % % % enddynamic\n") eMaxdist.text eMindist.text eNametrr.text eDirtrr.text eTextrr23.text eChktrr23.text eXxxtrr.text eDrvtrr.text eSprtrr.text eSpztrr.text to:ostream
				  
		      if (cb_Trainset2.checked) then
		   	  (   
			   Format ("node % % % dynamic % % % % % % % enddynamic\n") eMaxdist2.text eMindist2.text eNametrr2.text eDirtrr2.text eTextrr2.text eChktrr2.text eXxxtrr2.text eDrvtrr2.text eSprtrr2.text eSpztrr2.text to:ostream
              )
	--		  if (cb_Trainset3.checked) then
	--	   	  (   
	--		   Format ("node % % % dynamic % % % % % % % enddynamic\n") eMaxdist3.text eMindist3.text eNametrr3.text eDirtrr3.text eTextrr3.text eChktrr3.text eXxxtrr3.text eDrvtrr3.text eSprtrr3.text eSpztrr3.text to:ostream
      --        )
	    	  if (cb_Trainset4.checked) then
		   	  (   
			   Format ("node % % % dynamic % % % % % % % enddynamic\n") eMaxdist4.text eMindist4.text eNametrr4.text eDirtrr4.text eTextrr4.text eChktrr4.text eXxxtrr4.text eDrvtrr4.text eSprtrr4.text eSpztrr4.text to:ostream
              )
			  if (cb_Trainset5.checked) then
		   	  (   
			   Format ("node % % % dynamic % % % % % % % enddynamic\n") eMaxdist5.text eMindist5.text eNametrr5.text eDirtrr5.text eTextrr5.text eChktrr5.text eXxxtrr5.text eDrvtrr5.text eSprtrr5.text eSpztrr5.text to:ostream
              )
			  if (cb_Trainset6.checked) then
		   	  (   
			   Format ("node % % % dynamic % % % % % % % enddynamic\n") eMaxdist6.text eMindist6.text eNametrr6.text eDirtrr6.text eTextrr6.text eChktrr6.text eXxxtrr6.text eDrvtrr6.text eSprtrr6.text eSpztrr6.text to:ostream
              )
			  if (cb_Trainset7.checked) then
		   	  (   
			   Format ("node % % % dynamic % % % % % % % enddynamic\n") eMaxdist7.text eMindist7.text eNametrr7.text eDirtrr7.text eTextrr7.text eChktrr6.text eXxxtrr7.text eDrvtrr7.text eSprtrr7.text eSpztrr7.text to:ostream
              )
			  if (cb_Trainset8.checked) then
		   	  (   
			   Format ("node % % % dynamic % % % % % % % enddynamic\n") eMaxdist8.text eMindist8.text eNametrr8.text eDirtrr8.text eTextrr8.text eChktrr8.text eXxxtrr8.text eDrvtrr8.text eSprtrr8.text eSpztrr8.text to:ostream
              )
			  if (cb_Trainset9.checked) then
		   	  (   
			   Format ("node % % % dynamic % % % % % % % enddynamic\n") eMaxdist9.text eMindist9.text eNametrr9.text eDirtrr9.text eTextrr9.text eChktrr9.text eXxxtrr9.text eDrvtrr9.text eSprtrr9.text eSpztrr9.text to:ostream
              )
			  if (cb_Trainset10.checked) then
		   	  (   
			   Format ("node % % % dynamic % % % % % % % enddynamic\n") eMaxdist10.text eMindist10.text eNametrr10.text eDirtrr10.text eTextrr10.text eChktrr10.text eXxxtrr10.text eDrvtrr10.text eSprtrr10.text eSpztrr10.text to:ostream
              )
			  
			  Format ("%\n") eNdtrainset.text to:ostream
            )
			
        function GettexFileStream =
		(
			fname3 = GetOpenFileName types:"All Files(*.*)|*.*|"
			if fname3 == undefined then
				return undefined
		
			eText3 = filenameFromPath fname3 as string
			if eText3 == undefined then
			(
				MessageBox "Couldn't open file for reading !"
				return undefined
			)
			dirr1r = getFilenamePath fname3 as string
			if dirr1r == undefined then
			(
				MessageBox "Couldn't open file for reading !"
				return undefined
			)

            eDirtrr.text= dirr1r
	        eTextrr23.text= eText3
			return eText3
			close eText3
			close dirr1r
		)

        function GetChFileStream =
		(
			fname12 = GetOpenFileName types:"Chk Files(*.chk)|*.chk|All Files(*.*)|*.*|"
			if fname12 == undefined then
				return undefined
		
			eChk2 = getFilenameFile fname12 as string
			if eChk2 == undefined then
			(
				MessageBox "Couldn't open file for reading !"
				return undefined
			)
	        eChktrr23.text= eChk2
			return eChk2
			close eChk2
		)
    on texturelok pressed do
    (
     GettexFileStream()
	)
	on chklok pressed do
    (
	 GetChFileStream()
	)

		------------------------------------------------------------------------------------------------
	)	
	rollout SCNExport "Export scenerii" 
	(
		Group "Opcje" 
		(
		 checkbox cb_exportSelOnly "Exportuj tylko zaznaczone" checked:true   
		 checkbox cb_atmdefs "Dodaj atmo light camera definicje"
		 checkbox cb_Trainset "Dodaj definicje polozenia pociagow"    
		 checkbox cb_Rozszezenia "Dodaj rozszezenia plikow dla obiektow MESH(Plane, lasy, ploty)"  
		 checkbox cb_NodeType "MESH jako jeden obiekt"
		)
		button btn_export "Export scenerii..."  
       		
	
		-------------------------------------------------------------------------------------
		--ISDR --16.07.2011 -- Dodanie rozszezenia do sciezki tekstury
		function DodajRozszezenie tex1=
		(
		if cb_Rozszezenia.checked==false then
			(
			pos1 = findString tex1 ".dds"
			if pos1!=undefined then 
				(
				return (subString tex1 1 (pos1-1))
				)
				
			pos1 = findString tex1 ".tga"
			if pos1!=undefined then 
				(
				return (subString tex1 1 (pos1-1))
				)
				
			pos1 = findString tex1 ".bmp"
			if pos1!=undefined then 
				(
				return (subString tex1 1 (pos1-1))
				)
			
			)
		else return tex1
		
		)
		
		-------------------------------------------------------------------------------------
		function ExportMesh meshObj =
		(
	
	 		Format ("\n") to:ostream
	 		Format ("//-------------------------------------------------\n") to:ostream
	 		Format ("// %\n") meshObj.name to:ostream
 			Format ("//-------------------------------------------------\n") to:ostream
			
		
			varname= meshObj.name
			for i = 1 to varname.count do
				if varname[i] == " " then varname[i] = "_"
			 
			bHasMap= false;
			texture= "none";
                     texturepath= "none";
			if (meshObj.material!=undefined) then
			(
				if ((meshObj.material.mapEnables[2]) and (meshObj.material.maps[2]!=undefined)) then
				(
					--pobieramy cala ciezke lacznie z koncowa nazwa pliku
					local path = (getFilenamePath meshObj.material.maps[2].filename) + (filenameFromPath meshObj.material.maps[2].filename)
					local filtr = "\\"
					--filtrujemy przez / aby uzyskac poszczegolne skladniki
					local t = (filterString path filtr)
					local jestFolder = false
					--sprawdzamy kolei wszystkie wartoci w tablicy szukajac wartoci extures (t cina podczas filtrowania)
					for i=1 to t.count do
					(
						if jestFolder == false then
						(
							--jeli jeszcze nie doszedl do tego pola to nic nie zapisujemy
							--jesli doszedl to dajemy, ze od tej pory reszte pol bedzie zapisywal
							if (findString t[i] "extures") != undefined then
							(
								jestFolder = true
								texture = ""
							)
							else
							(
								texture = t[i]
							)
						)
						else
						(
							--zapisujemy wartoc do ciezki
							texture = texture + t[i]
							--jeli pole nie jest ostatnie to dodajemy \
							if i < t.count then
								texture = texture + "\\"
						)
					)
					texture  = DodajRozszezenie texture
					bHasMap= true;
				)
				
			)
			else
			(
--				Format ("Diffuse: % % %\n") meshObj.wireColor.r meshObj.wireColor.b meshObj.wireColor.g to:ostream
--				Format ("Map: none\n") to:ostream
			)				
			update meshObj true true true
			if (meshObj.numFaces) > 0 then
			(
				if (bHasMap==true) then
				(
				
					maxdist= (getUserProp meshObj "MaxDistance")
					if (maxdist==undefined) then
						maxdist= 1000                     
					mindist= (getUserProp meshObj "MinDistance")
					if (mindist==undefined) then
							mindist= 0
							
					if cb_NodeType.checked then
					(
					
					Format ("node % % none triangles material ambient: % % % ") maxdist mindist meshObj.material.ambient.r meshObj.material.ambient.g meshObj.material.ambient.b to:ostream
					Format ("diffuse: % % % ") meshObj.material.diffuse.r meshObj.material.diffuse.g meshObj.material.diffuse.b to:ostream
					Format ("specular: % % % ") meshObj.material.specular.r meshObj.material.specular.g meshObj.material.specular.b to:ostream		
					Format (" endmaterial %\n") texture to:ostream				
					)
					
				for i = 1 to (meshObj.numFaces) do
				(
						 
					vrt= (GetVert meshObj (GetFace meshObj i).x )
					vrt2= (GetVert meshObj (GetFace meshObj i).y )
					vrt3= (GetVert meshObj (GetFace meshObj i).z )
					
--					(Format "% % % \n" vrt vrt2 vrt3)

					
					if (vrt!=vrt2 and vrt!=vrt3 and vrt2!=vrt3) then
					(
					
						if cb_NodeType.checked == false then
						(
						Format ("node % % none triangles material ambient: % % % ") maxdist mindist meshObj.material.ambient.r meshObj.material.ambient.g meshObj.material.ambient.b to:ostream
						Format ("diffuse: % % % ") meshObj.material.diffuse.r meshObj.material.diffuse.g meshObj.material.diffuse.b to:ostream
						Format ("specular: % % % ") meshObj.material.specular.r meshObj.material.specular.g meshObj.material.specular.b to:ostream		
						Format (" endmaterial %\n") texture to:ostream
						)
						
--						tu= (GetTVert meshObj (GetTVFace meshObj i).x ).x;
--						tv= (GetTVert meshObj (GetTVFace meshObj i).x ).y;
					
						Format ("% ") (-vrt.x) to:ostream
						Format ("% ") (vrt.z) to:ostream
						Format ("% 	") (vrt.y) to:ostream
						norm= getNormal meshObj (GetFace meshObj i).x
						Format ("% ") (-norm.x) to:ostream
						Format ("% ") (norm.z) to:ostream
						Format ("%  ") (norm.y) to:ostream
--						Format ("0.0 ")  to:ostream
--						Format ("0.0 ")  to:ostream
						Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).x ).x) to:ostream
						Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).x ).y) to:ostream
						
						Format ("end\n") to:ostream
					
						vrt= vrt2
						Format ("% ") (-vrt.x) to:ostream
						Format ("% ") (vrt.z) to:ostream
						Format ("% 	") (vrt.y) to:ostream
						norm= getNormal meshObj (GetFace meshObj i).y
						Format ("% ") (-norm.x) to:ostream
						Format ("% ") (norm.z) to:ostream
						Format ("%  ") (norm.y) to:ostream
--						Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).y ).x-tu) to:ostream
--						Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).y ).y-tv) to:ostream
						Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).y ).x) to:ostream
						Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).y ).y) to:ostream
						Format ("end\n") to:ostream
					
						vrt= vrt3
						Format ("% ") (-vrt.x) to:ostream
						Format ("% ") (vrt.z) to:ostream
						Format ("% 	") (vrt.y) to:ostream
						norm= getNormal meshObj (GetFace meshObj i).z
						Format ("% ") (-norm.x) to:ostream
						Format ("% ") (norm.z) to:ostream
						Format ("%  ") (norm.y) to:ostream
--						Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).z ).x-tu) to:ostream
--						Format ("% \n") ((GetTVert meshObj (GetTVFace meshObj i).z ).y-tv) to:ostream
						Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).z ).x) to:ostream
						Format ("% ") ((GetTVert meshObj (GetTVFace meshObj i).z ).y) to:ostream
						
						if (meshObj.numFaces > i) AND (cb_NodeType.checked) then 
						(
						Format ("end\n") to:ostream
						)
						
						if cb_NodeType.checked == false then
						(	
						Format ("\nendtri\n\n") to:ostream
						--Format ("\n") to:ostream
						)
						
						
					)
					else
						(Format "Degenerated triangle!")
						

				)	
				
					if cb_NodeType.checked then
					(	
					Format ("\nendtri\n") to:ostream
					)
					
				)
			)
		)	
		-------------------------------------------------------------------------------------
		function ExportSpline splObj =
		(
		
--			convertToSplineShape splObj;
			
--			return true;
			bError= false
		
			varname= splObj.name
			for i = 1 to varname.count do
				if varname[i] == " " then varname[i] = "_"
				
			--print (getUserProp splObj "Type")
			mindist= "0"
			prop= (getUserProp splObj "MinDistance")
			if (prop!=undefined) then
				mindist= prop
			maxdist= "1000"
			prop= (getUserProp splObj "MaxDistance")
			if (prop!=undefined) then
				maxdist= prop
			case (getUserProp splObj "Type") of
			(
				"normal":
				(
					if ((numSplines splObj)==1) and ((numKnots splObj 1)==2) then
					(
--						Format ("node -1 0 % track normal % % % % % \n") varname (getUserProp splObj "Texture1") (getUserProp splObj "Texture2") (getUserProp splObj "Category") (getUserProp splObj "Width") (getUserProp splObj "Sound") (getUserProp splObj "Quality") (getUserProp splObj "Damage") (getUserProp splObj "Visibility") to:ostream
     						evis= (getUserProp splObj "Visibility")
					        if (evis=="vis") then
                                                 (
						   Format ("node % % % track normal % % % % % % % % \n % % % % % % \n") maxdist mindist varname  (getUserProp splObj "Length") (getUserProp splObj "TrackWidth") (getUserProp splObj "Friction") (getUserProp splObj "SoundDist") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Environment") (getUserProp splObj "Visibility") (getUserProp splObj "Tex1") (getUserProp splObj "TexLength") (getUserProp splObj "Tex2") (getUserProp splObj "TexPar1") (getUserProp splObj "TexPar2") (getUserProp splObj "TexPar3") to:ostream
						   --print (getUserProp splObj "Length")
                                                 )
						else
                                                 (
						   Format ("node % % % track normal % % % % % % % % \n") maxdist mindist varname  (getUserProp splObj "Length") (getUserProp splObj "TrackWidth") (getUserProp splObj "Friction") (getUserProp splObj "SoundDist") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Environment") (getUserProp splObj "Visibility") to:ostream
						-- print (getUserProp splObj "Length")
						)
 							
						pt= getKnotPoint splObj 1 1						
						Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
						Format ("% ") (formattedPrint (pt.z) format:".3f") to:ostream
						Format ("%  %  //point 1\n") (formattedPrint (pt.y) format:".3f") (getUserProp splObj "Roll1") to:ostream
					
						if ((getSegmentType splObj 1 1)==#curve) then
						(
							pt= (getOutVec splObj 1 1) - (getKnotPoint splObj 1 1)
							Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
							Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream
							Format ("%  //control vector 1\n") (formattedPrint (pt.y) format:".3f" ) to:ostream

							pt= (getInVec splObj 1 2) - (getKnotPoint splObj 1 2)
							Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
							Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream
							Format ("%  //control vector 2\n") (formattedPrint (pt.y) format:".3f" ) to:ostream
						)
						else
						(
							Format ("0.0 0.0 0.0  //control vector 1\n") to:ostream
							Format ("0.0 0.0 0.0  //control vector 2\n") to:ostream
						)

						pt= getKnotPoint splObj 1 2
						Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
						Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream
						Format ("%  %  //point 2\n") (formattedPrint (pt.y) format:".3f" ) (getUserProp splObj "Roll2") to:ostream
						Format ("% \n") (getUserProp splObj "Radius1") to:ostream						
					)
					else
					(
						--messageBox "Track export error: " + varname
						select splObj
						messageBox "Nie mozna eksportowac toru - popraw tor!!!"
						exit
					)
				)
				"switch":
				(

					if ((numSplines splObj)==2) and ((numKnots splObj 1)==2) and ((numKnots splObj 2)==2) then
					(
--						Format ("node -1 0 % track switch % % % % % % \n % \n") varname (getUserProp splObj "Texture1") (getUserProp splObj "Texture2") (getUserProp splObj "Category") (getUserProp splObj "Width") (getUserProp splObj "Sound") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Visibility") (getUserProp splObj "State") to:ostream
--						Format ("node % % % track switch % % % % % % % % % % % % % % \n") (getUserProp splObj "MaxDistance") (getUserProp splObj "MinDistance") varname  (getUserProp splObj "Length") (getUserProp splObj "TrackWidth") (getUserProp splObj "Friction") (getUserProp splObj "SoundDist") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Environment") (getUserProp splObj "Visibility") (getUserProp splObj "Tex1") (getUserProp splObj "TexLength") (getUserProp splObj "Tex2") (getUserProp splObj "TexPar1") (getUserProp splObj "TexPar2") (getUserProp splObj "TexPar3") to:ostream
     					evis= (getUserProp splObj "Visibility")
					    if (evis=="vis") then
                        (
							Format ("node % % % track switch % % % % % % % % \n % % % % % % \n") maxdist mindist varname  (getUserProp splObj "Length") (getUserProp splObj "TrackWidth") (getUserProp splObj "Friction") (getUserProp splObj "SoundDist") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Environment") (getUserProp splObj "Visibility") (getUserProp splObj "Tex1") (getUserProp splObj "TexLength") (getUserProp splObj "Tex2") (getUserProp splObj "TexPar1") (getUserProp splObj "TexPar2") (getUserProp splObj "TexPar3") to:ostream
						)
						else
                        (
							Format ("node % % % track switch % % % % % % % % \n") maxdist mindist varname  (getUserProp splObj "Length") (getUserProp splObj "TrackWidth") (getUserProp splObj "Friction") (getUserProp splObj "SoundDist") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Environment") (getUserProp splObj "Visibility") to:ostream
						)
						pt= getKnotPoint splObj 1 1
						Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
						Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream
						Format ("%  0.1  //point 1\n") (formattedPrint (pt.y) format:".3f" ) to:ostream

				
						if ((getSegmentType splObj 1 1)==#curve) then
						(
							pt= (getOutVec splObj 1 1) - (getKnotPoint splObj 1 1)
							Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
							Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream
							Format ("%  //control vector 1\n") (formattedPrint (pt.y) format:".3f" ) to:ostream

							pt= (getInVec splObj 1 2) - (getKnotPoint splObj 1 2)
							Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
							Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream
							Format ("%  //control vector 2\n") (formattedPrint (pt.y) format:".3f" ) to:ostream
						)
						else
						(
							Format ("0.0 0.0 0.0  //control vector 1\n") to:ostream
							Format ("0.0 0.0 0.0  //control vector 2\n") to:ostream
						)

						pt= getKnotPoint splObj 1 2
						Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
						Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream
						Format ("%  -0.1  //point 2\n") (formattedPrint (pt.y) format:".3f" ) to:ostream
						Format ("% \n") (getUserProp splObj "Radius1") to:ostream			


						pt= getKnotPoint splObj 2 1
						Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
						Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream
						Format ("%  0  //point 1\n") (formattedPrint (pt.y) format:".3f" ) to:ostream
					
						if ((getSegmentType splObj 2 1)==#curve) then
						(
							pt= (getOutVec splObj 2 1) - (getKnotPoint splObj 2 1)
							Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
							Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream
							Format ("%  //control vector 1\n") (formattedPrint (pt.y) format:".3f" ) to:ostream

							pt= (getInVec splObj 2 2) - (getKnotPoint splObj 2 2)
							Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
							Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream
							Format ("%  //control vector 2\n") (formattedPrint (pt.y) format:".3f" ) to:ostream
						)
						else
						(
							Format ("0.0 0.0 0.0  //control vector 1\n") to:ostream
							Format ("0.0 0.0 0.0  //control vector 2\n") to:ostream
						)
						
						
						pt= getKnotPoint splObj 2 2
						Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
						Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream
						Format ("%  0  //point 2\n") (formattedPrint (pt.y) format:".3f" ) to:ostream
		
						Format ("% \n") (getUserProp splObj "Radius2") to:ostream		
						
					)
					else
					(
						select splObj
						messageBox "Nie mozna eksportowac rozjazdu - popraw rozjazd!!!"
						exit
					)

				)
				"road":
				(
					if ((numSplines splObj)==1) and ((numKnots splObj 1)==2) then
					(
     					evis= (getUserProp splObj "Visibility")
						mindist= "0"
						prop= (getUserProp splObj "MinDistance")
						if (prop!=undefined) then
							mindist= prop
						maxdist= "800"
						prop= (getUserProp splObj "MaxDistance")
						if (prop!=undefined) then
							maxdist= prop
					    if (evis=="vis") then
						(
							Format ("node % % % track road % % % % % % % % \n % % % % % % \n") maxdist mindist varname  (getUserProp splObj "Length") (getUserProp splObj "TrackWidth") (getUserProp splObj "Friction") (getUserProp splObj "SoundDist") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Environment") (getUserProp splObj "Visibility") (getUserProp splObj "Tex1") (getUserProp splObj "TexLength") (getUserProp splObj "Tex2") (getUserProp splObj "TexPar1") (getUserProp splObj "TexPar2") (getUserProp splObj "TexPar3") to:ostream
						)
						else
						(
							Format ("node % % % track road % % % % % % % % \n") maxdist mindist varname  (getUserProp splObj "Length") (getUserProp splObj "TrackWidth") (getUserProp splObj "Friction") (getUserProp splObj "SoundDist") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Environment") (getUserProp splObj "Visibility") to:ostream
						)
 						
						pt= getKnotPoint splObj 1 1
						Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
						Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream
						Format ("%  %  //point 1\n") (formattedPrint (pt.y) format:".3f" ) (getUserProp splObj "Roll1") to:ostream
					
						if ((getSegmentType splObj 1 1)==#curve) then
						(
							pt= (getOutVec splObj 1 1) - (getKnotPoint splObj 1 1)
							Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
							Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream
							Format ("%  //control vector 1\n") (formattedPrint (pt.y) format:".3f" ) to:ostream
							pt= (getInVec splObj 1 2) - (getKnotPoint splObj 1 2)
							Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
							Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream
							Format ("%  //control vector 2\n") (formattedPrint (pt.y) format:".3f" ) to:ostream
						)
						else
						(
							Format ("0.0 0.0 0.0  //control vector 1\n") to:ostream
							Format ("0.0 0.0 0.0  //control vector 2\n") to:ostream
						)

						pt= getKnotPoint splObj 1 2
						Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
						Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream
						Format ("%  %  //point 2\n") (formattedPrint (pt.y) format:".3f" ) (getUserProp splObj "Roll2") to:ostream
						Format ("% \n") (getUserProp splObj "Radius1") to:ostream						
					)
					else
					(
						select splObj
						messageBox "Nie mozna eksportowac drogi - popraw droge!!!"
						exit
					)
				)
				"river":
				(
					if ((numSplines splObj)==1) and ((numKnots splObj 1)==2) then
					(
						mindist= "0"
						prop= (getUserProp splObj "MinDistance")
						if (prop!=undefined) then
							mindist= prop
						maxdist= "800"
						prop= (getUserProp splObj "MaxDistance")
						if (prop!=undefined) then
							maxdist= prop
     					evis= (getUserProp splObj "Visibility")
					    if (evis=="vis") then
                        (
							Format ("node % % % track river % % % % % % % % \n % % % % % % \n") maxdist mindist varname  (getUserProp splObj "Length") (getUserProp splObj "TrackWidth") (getUserProp splObj "Friction") (getUserProp splObj "SoundDist") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Environment") (getUserProp splObj "Visibility") (getUserProp splObj "Tex1") (getUserProp splObj "TexLength") (getUserProp splObj "Tex2") (getUserProp splObj "TexPar1") (getUserProp splObj "TexPar2") (getUserProp splObj "TexPar3") to:ostream
						)
						else
                        (
							Format ("node % % % track river % % % % % % % % \n") maxdist mindist varname  (getUserProp splObj "Length") (getUserProp splObj "TrackWidth") (getUserProp splObj "Friction") (getUserProp splObj "SoundDist") (getUserProp splObj "Quality") (getUserProp splObj "DamageFlag") (getUserProp splObj "Environment") (getUserProp splObj "Visibility") to:ostream
						)
 							
						pt= getKnotPoint splObj 1 1
						Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
						Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream
						Format ("%  %  //point 1\n") (formattedPrint (pt.y) format:".3f" ) (getUserProp splObj "Roll1") to:ostream
					
						if ((getSegmentType splObj 1 1)==#curve) then
						(
							pt= (getOutVec splObj 1 1) - (getKnotPoint splObj 1 1)
							Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
							Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream
							Format ("%  //control vector 1\n") (formattedPrint (pt.y) format:".3f" ) to:ostream

							pt= (getInVec splObj 1 2) - (getKnotPoint splObj 1 2)
							Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
							Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream
							Format ("%  //control vector 2\n") (formattedPrint (pt.y) format:".3f" ) to:ostream
						)
						else
						(
							Format ("0.0 0.0 0.0  //control vector 1\n") to:ostream
							Format ("0.0 0.0 0.0  //control vector 2\n") to:ostream
						)

						pt= getKnotPoint splObj 1 2
						Format ("% ") (formattedPrint (-pt.x) format:".3f" ) to:ostream
						Format ("% ") (formattedPrint (pt.z) format:".3f" ) to:ostream						
						Format ("%  %  //point 2\n") (formattedPrint (pt.y) format:".3f" ) (getUserProp splObj "Roll2") to:ostream
						Format ("% \n") (getUserProp splObj "Radius1") to:ostream						
					)
					else
					(
						select splObj
						messageBox "Nie mozna eksportowac rzeki - popraw rzeke!!!"
						exit

					)
				)
				"traction":
				(
					def= ""
					prop= (getUserProp splObj "Default")
					if (prop!=undefined) then
						def= prop
					mindist= "0"
					prop= (getUserProp splObj "MinDistance")
					if (prop!=undefined) then
						mindist= prop

					maxdist= "600"
					prop= (getUserProp splObj "MaxDistance")
					if (prop!=undefined) then
						maxdist= prop


					nominalvoltage= "3500"
					prop= (getUserProp splObj "nominalvoltage")
					--prop= (getUserProp splObj "NominalVoltage")
					if (prop!=undefined) then
						nominalvoltage= prop

					maxcurrent= "4500"
					prop= (getUserProp splObj "maxcurrent")
					--prop= (getUserProp splObj "MaxCurrent")
					if (prop!=undefined) then
						maxcurrent= prop

					resistivity= "0.01"
					prop= (getUserProp splObj "resistivity")
					--prop= (getUserProp splObj "Resistivity")
					if (prop!=undefined) then
						resistivity= prop

					material= "Cu"
					prop= (getUserProp splObj "material")
					if (prop!=undefined) then
						material= prop

					wirethickness= "3"
					prop= (getUserProp splObj "wirethickness")
					--prop= (getUserProp splObj "WireThickness")
					if (prop!=undefined) then
						wirethickness= prop

					damageflag= "1"
					prop= (getUserProp splObj "damageflag")
					--prop= (getUserProp splObj "DamageFlag")
					if (prop!=undefined) then
						damageflag= prop

					h1= 1.7
					prop= (getUserProp splObj "h1")
					if (prop!=undefined) then
						h1= prop

					h2= 1.7
					prop= (getUserProp splObj "h2")
					if (prop!=undefined) then
						h2= prop

					hmin= "0.4"
					prop= (getUserProp splObj "hmin")
					--prop= (getUserProp splObj "hMin")
					if (prop!=undefined) then
						hmin= prop

					deltal= "4.0"
					prop= (getUserProp splObj "deltal")
					
					if (prop!=undefined) then
						deltal= prop

					wires= "2"
					prop= (getUserProp splObj "wires")
					if (prop == undefined) then 
					(
					prop= (getUserProp splObj "Wires")
						)
						
					if (prop != undefined) then
						wires= prop
						
						
					wireoffset= "0.04"
					prop= (getUserProp splObj "wireoffset")
					--prop= (getUserProp splObj "WireOffset")
					if (prop!=undefined) then
						wireoffset= prop

					visibility= "vis"
					prop= (getUserProp splObj "visibility")
					--prop= (getUserProp splObj "Visibility")
					if (prop!=undefined) then
						visibility= prop

					for i=1 to (numKnots splObj 1) do
					(
						kt= getKnotType splObj 1 i
						(
							v1= [0,0,0]
							v2= [0,0,0]
							if (i>1) then
							(
								v1= (getKnotPoint splObj 1 (i-1))-(getKnotPoint splObj 1 i) 
								v1.z=0
								v1= (normalize v1)
								pt2= (getKnotPoint splObj 1 i) 
								pt1= (getKnotPoint splObj 1 (i-1)) 
								Format ("node % % none traction % % % % % % %\n") maxdist mindist varname nominalvoltage maxcurrent resistivity material wirethickness damageflag to:ostream
								Format ("% % %\n% % %\n") -pt1.x pt1.z pt1.y -pt2.x pt2.z pt2.y to:ostream
								Format ("% % %\n% % %\n% % % % % \n") -pt1.x (pt1.z+h1) pt1.y -pt2.x (pt2.z+h2) pt2.y hmin deltal wires wireoffset visibility to:ostream								
								Format ("endtraction\n") to:ostream
							)
								
							if (i<(numKnots splObj 1)) then
							(
								v2= (getKnotPoint splObj 1 i)-(getKnotPoint splObj 1 (i+1)) 
								v2.z=0
								v2= (normalize v2)
							)
							vec= v1+v2
						)

						vec.z= 0
						vec= normalize vec
						Format ("vec % \n") vec
						
						a= (atan2 vec.y vec.x) + 90
						pt= (getKnotPoint splObj 1 i)
						
						def= ""
						prop= (getUserProp splObj (i as string))
						if (prop==undefined) then
							prop= def
						if (prop!="") then
						(
							arr= filterString prop ";"
							if arr[2] == undefined then arr[2] = "none"
							Format ("include % % % % % % end\n\n") arr[1] (-pt.x) (pt.z) (pt.y) a arr[2] to:ostream
						)
					)
					return true
				)
				"hekt":
				(
					step= 100
					startDistance= 0
					length= (curveLength splObj 1)
					sideDistance= 3.7
					style= 2
					
					prop= (getUserProp splObj "step")
					if (prop!=undefined) then
						step= prop
						
					prop= (getUserProp splObj "startDistance")
					if (prop!=undefined) then
						startDistance= prop
						
					prop= (getUserProp splObj "overrideLength")
					if (prop!=undefined) then
						length= prop
					
					prop= (getUserProp splObj "sideDistance")
					if (prop!=undefined) then
						sideDistance= prop
					
					prop= (getUserProp splObj "style")
					if (prop!=undefined) then
						style= prop as integer
						
			
					s= 0.0
					
					if (style==1) then
					(
						sign= 1
						side= 1
						
					)
					else
					if (style==-1) then
					(
						sign= 1
						side= -1
						
					)
					else
					(
						sign= -1
						side= 1
					)	
					
					while (s<length) do
					(
						km_digits=  (floor ((s + startDistance)/1000)) as integer
						tmp= (((s + startDistance)/1000-km_digits)*10) 
						sm_digits= (floor (tmp+0.5)) as integer

						format "s=% k=% sm=% side=% \n" s km_digits sm_digits side
						
						i= s/(curveLength splObj 1)

						vec= lengthTangent splObj 1 i
						parallel= [vec.y,-vec.x,vec.z]
						pt= (lengthInterp splObj 1 i)+side*(normalize parallel)*sideDistance
						a= (atan2 vec.y vec.x) + 90
						km_str= (km_digits as string)
						sm_str= sm_digits as string
						if (km_digits<10) then
						(
							Format ("include;slupek-waski.inc;%;%;%;%;%;slupek-%.t3d;slupek-%.t3d;end\n") (-pt.x) (pt.z) (pt.y) a (a+180) km_str sm_str to:ostream
						)
						else
						if (km_digits<100) then						
						(
							Format ("include slupek-sredni.inc % % % % % slupek-%lsr.t3d slupek-%psr.t3d slupek-%.t3d end\n") (-pt.x) (pt.z) (pt.y) a (a+180) km_str[1] km_str[2] sm_str to:ostream
						)
						else
						(
							Format ("include slupek-szeroki.inc % % % % % slupek-%lsz.t3d slupek-%.t3d slupek-%psz.t3d slupek-%.t3d end\n") (-pt.x) (pt.z) (pt.y) a (a+180) km_str[1] km_str[2] km_str[3] sm_str to:ostream
						)
						
						side= side*sign
						s= s+step
					)
					
						
--						a= (atan2 vec.y vec.x) + 90
--						pt= (getKnotPoint splObj 1 i)
						
					return true
				)
				
				
				--ISDR 04.12.2011
			"lines":
			(
			maxDis = getUserProp splObj "MaxDistance"
			if maxDis == undefined then maxDis = 300
			
			minDis = getUserProp splObj "MinDistance"
			if minDis == undefined then minDis = 0
		
			Thickness	 = getUserProp splObj "Thickness"
			if Thickness == undefined then Thickness = 1
			
			
			--print (Format ("% % ") splObj.name (numKnots splObj) ).material.ambient.r
			if splObj.material!=undefined then  Format ("node % % % lines % % % % \n") maxDis minDis splObj.name splObj.material.ambient.r splObj.material.ambient.g  splObj.material.ambient.b Thickness to:ostream
			else Format ("node % % % lines % % % % \n") maxDis minDis splObj.name splObj.wireColor.r splObj.wireColor.g  splObj.wireColor.b Thickness to:ostream
			for iSpl=1 to (numSplines splObj) do
			(
			
			
			
			for i=1 to ((numKnots splObj iSpl)-1) do
				(
				
				
				point3_1 = [0 , 0 , 0]
				point3_1 = (getKnotPoint splObj iSpl i)
				
			
				point3_2 = [0 , 0 , 0]
				point3_2 = (getKnotPoint splObj iSpl (i+1))
				
				Format ("% % % \t % % %\n") -point3_1[1] point3_1[3] point3_1[2] -point3_2[1] point3_2[3] point3_2[2] to:ostream

				
				)
			
			
			)
			Format ("endline \n\n") point3  to:ostream
			return true
-- -pt1.x pt1.z pt1.y -pt2.x pt2.z pt2.y to:ostream
			)
				default: bError= true
				--tutaj powinno byc od eventow
			)
			
--			ev= (getUserProp splObj "Event")
--			if (ev!=undefined) then
--			(
--				Format ("event1 % \n") ev to:ostream
--				Format ("event2 % \n") ev to:ostream
--			)

			
			ev= (getUserProp splObj "Event0")
			if (ev==undefined) then
			 ev= (getUserProp splObj "event0")
			if (ev!=undefined) then
				Format ("event0 % \n") ev to:ostream

			ev= (getUserProp splObj "Eventall0")
			if (ev==undefined) then
			ev= (getUserProp splObj "eventall0")
			if (ev!=undefined) then
			Format ("eventall0 % \n") ev to:ostream

			ev= (getUserProp splObj "Event1")
			if (ev==undefined) then
			 ev= (getUserProp splObj "event1")
			if (ev!=undefined) then
			 Format ("event1 % \n") ev to:ostream
			 
			ev= (getUserProp splObj "Eventall1")
			if (ev==undefined) then
			 ev= (getUserProp splObj "eventall1")
			if (ev!=undefined) then
			 Format ("eventall1 % \n") ev to:ostream

			ev= (getUserProp splObj "Event2")
			if (ev==undefined) then
			 ev= (getUserProp splObj "event2")
			if (ev!=undefined) then
			Format ("event2 % \n") ev to:ostream
					
			ev= (getUserProp splObj "Eventall2")
			if (ev==undefined) then
			 ev= (getUserProp splObj "eventall2")
			if (ev!=undefined) then
				Format ("eventall2 % \n") ev to:ostream
				
			ev= (getUserProp splObj "Velocity")
			if (ev!=undefined) then
				Format ("velocity % \n") ev to:ostream
				
			ev= (getUserProp splObj "Isolated")
			if (ev!=undefined) then
				Format ("isolated % \n") ev to:ostream

			ev= (getUserProp splObj "isolated")
			if (ev!=undefined) then
				Format ("isolated % \n") ev to:ostream

			ev= (getUserProp splObj "Trackbed")
			if (ev!=undefined) then
				Format ("trackbed % \n") ev to:ostream

			ev= (getUserProp splObj "trackbed")
			if (ev!=undefined) then
				Format ("trackbed % \n") ev to:ostream

			if ((getUserProp splObj "Type")!=undefined and (getUserProp splObj "Type")!="Lines") then
			(
				Format ("endtrack\n") to:ostream
--				Format ("\n") to:ostream
			)
			
			--TODO: Trzeba to porzadnie przerobic. Aby kazdy typ mial swoje event1 .. eventall velocity 
			str= (getUserProp splObj "ExportString")
			if (str!=undefined) then
			(
				v1= [0,0,0]
				v1= (getKnotPoint splObj 1 1)-(getKnotPoint splObj 1 2) 
				v1.z=0
				v1= (normalize v1)
				zrot= (atan2 v1.y v1.x) + 90
				Format "// additional:\n" to:ostream
				
				wys = (getUserProp splObj "TexPar1")
				if wys == undefined then wys = 0;
				 Format str splObj.name (-splObj.pos.x) (splObj.pos.z-wys) splObj.pos.y zrot to:ostream
				
				Format "\n" to:ostream
			)
			

				
			if ((getUserProp splObj "Type")!=undefined) then
				Format ("\n") to:ostream
		
		)
		
		function ExportDummy dumObj =
		(
			Format ("\n") to:ostream
			str= (getUserProp dumObj "ExportString")
			if (str!=undefined) then
			(
				if dumObj.name=="Gantry" then
				 Format str (-dumObj.pos.x) dumObj.pos.z dumObj.pos.y dumObj.rotation.z_rotation to:ostream
				else
				 Format str dumObj.name (-dumObj.pos.x) dumObj.pos.z dumObj.pos.y dumObj.rotation.z_rotation to:ostream
				Format "\n" to:ostream
			)
			Format ("\n") to:ostream
		)
global IncRot = #(
				"grass_rot.inc" , 
				"ip/pkp/w4.inc" )				
		function ExportPoint ptObj =
        (
			if ((getUserProp ptObj "iseventsw")!=sw) and ((getUserProp ptObj "swiat")!=nonne) do
			(
			  Format ("event % % % % % endevent\n") (getUserProp ptObj "E1") (getUserProp ptObj "E2") (getUserProp ptObj "E3") (getUserProp ptObj "E4") (getUserProp ptObj "E5") to:ostream
			)
			if ((getUserProp ptObj "lightsss")!=lights) and ((getUserProp ptObj "zwr")!=nie) do
			(
			  Format ("event % % % % % % % % % % % % endevent\n") (getUserProp ptObj "L2") (getUserProp ptObj "L3") (getUserProp ptObj "L4") (getUserProp ptObj "L5") (getUserProp ptObj "L6") (getUserProp ptObj "L7") (getUserProp ptObj "L8") (getUserProp ptObj "L9") (getUserProp ptObj "L10") (getUserProp ptObj "L11") (getUserProp ptObj "L12") (getUserProp ptObj "L13") to:ostream
			)
			if ((getUserProp ptObj "typetrainset" )!=trainset) then
			(
			Format ("trainset % % % % \n") (getUserProp ptObj "S1") (getUserProp ptObj "S2") (getUserProp ptObj "S3") (getUserProp ptObj "S4") to:ostream
			)
			
			if ((getUserProp ptObj "typedynamic" )!=dynamic) then
			(
			Format ("node % % % dynamic % % % % % % % enddynamic\n") (getUserProp ptObj "D1") (getUserProp ptObj "D2") (getUserProp ptObj "D3") (getUserProp ptObj "D4") (getUserProp ptObj "D5") (getUserProp ptObj "D6") (getUserProp ptObj "D7") (getUserProp ptObj "D8") (getUserProp ptObj "D9") (getUserProp ptObj "D10") to:ostream
			)

			if ((getUserProp ptObj "typeendtainset" )!=ENDtrainset) then
			(
			Format ("%\n") (getUserProp ptObj "SEND") to:ostream
			)
			Format ("\n") to:ostream
			str= (getUserProp ptObj "ExportString")
			if (str!=undefined) then
			(
			
				
				if ((findString str "grass_rot.inc" ) != undefined) then Format str ptObj.name (-ptObj.pos.x) ptObj.pos.z ptObj.pos.y (-ptObj.rotation.x_rotation) ptObj.rotation.z_rotation ptObj.rotation.y_rotation to:ostream
				else	Format str ptObj.name (formattedPrint (-ptObj.pos.x) format:".3f" ) (formattedPrint (ptObj.pos.z) format:".3f") (formattedPrint (ptObj.pos.y) format:".3f") ptObj.rotation.z_rotation ptObj.rotation.z_rotation to:ostream
				Format "\n" to:ostream
			)
			for i=1 to 20 do
			(
				str= (getUserProp ptObj ("ExportString"+(i as string)))
				if (str!=undefined) then
				(
					if ((findString str "grass_rot.inc" ) != undefined) then Format str ptObj.name (-ptObj.pos.x) ptObj.pos.z ptObj.pos.y (-ptObj.rotation.x_rotation) ptObj.rotation.z_rotation ptObj.rotation.y_rotation to:ostream
					else	Format str ptObj.name (formattedPrint (-ptObj.pos.x) format:".3f" ) (formattedPrint (ptObj.pos.z) format:".3f") (formattedPrint (ptObj.pos.y) format:".3f") ptObj.rotation.z_rotation ptObj.rotation.z_rotation to:ostream
					Format "\n" to:ostream
				)
			)
			
			--20 maj 2012
			-- ISDR
			-- Wprowadzono typ "IncludeRot" dla include dla ktorych dostosowano rozniez parametry p6 i p7 jako rotacyjne
			str= (getUserProp ptObj "IncludeRotP6P5P7")
			if (str!=undefined) then
			(
				Format str ptObj.name (-ptObj.pos.x) ptObj.pos.z ptObj.pos.y (-ptObj.rotation.z_rotation) ptObj.rotation.x_rotation (-ptObj.rotation.y_rotation) to:ostream
				Format "\n" to:ostream
			)
			
			str= (getUserProp ptObj "IncludeRotP5P6P7")
			if (str!=undefined) then
			(
				Format str ptObj.name (-ptObj.pos.x) ptObj.pos.z ptObj.pos.y (-ptObj.rotation.x_rotation) ptObj.rotation.z_rotation (-ptObj.rotation.y_rotation) to:ostream
				Format "\n" to:ostream
			)
			
			--25.01.2010 by ZiomalCl
			--Wprowadzenie specjalnych parametrow przy wstawianiu obiektow o losowych parametrach wiaze ze soba
			--koniecznosc zmian w tym pliku (parametry eksportowane za pomoca %;%;%)
			str= (getUserProp ptObj "BudynekZiomalCl")  
			if (str!=undefined) then
			(
				Format str (-ptObj.pos.x)  ptObj.pos.y  to:ostream
				Format "\n" to:ostream
			)
			
			str= (getUserProp ptObj "DrzewaZiomalCl")  
			if (str!=undefined) then
			(
				Format str ptObj.name (-ptObj.pos.x)  ptObj.pos.y  to:ostream
				Format "\n" to:ostream
			)
			
			str= (getUserProp ptObj "KrzakiZiomalCl")  
			if (str!=undefined) then
			(
				Format str ptObj.name (-ptObj.pos.x)  ptObj.pos.y  to:ostream
				Format "\n" to:ostream
			)
			Format ("\n") to:ostream
		)
		-------------------------------------------------------------------------------------
		function ExportNode1 node =
		(
			if ((getUserProp node "ExportLast")!=true) then
			(
				Format ("Node: % % %\n") (superClassOf node) (classOf node) node.name
				if SuperClassOf node == shape then
					ExportSpline node
				if SuperClassOf node == Helper and ClassOf node == Dummy and not (isGroupHead node) then
					ExportDummy node
				if (SuperClassOf node == GeometryClass) then
				(
					convertToMesh node
					if (ClassOf node == Editable_mesh) then
						ExportMesh node
				)
				if SuperClassOf node == Helper and ClassOf node == Point then
					ExportPoint node
			)
	
				return true
		)
	
		-------------------------------------------------------------------------------------
		function ExportNode2 node =
		(
			if ((getUserProp node "ExportLast")==true) then
			(
				Format ("Node: % % %\n") (superClassOf node) (classOf node) node.name
				if SuperClassOf node == shape then
					ExportSpline node
				if SuperClassOf node == Helper and ClassOf node == Dummy and not (isGroupHead node) then
					ExportDummy node
				if (SuperClassOf node == GeometryClass) then
				(
					convertToMesh node
					if (ClassOf node == Editable_mesh) then
						ExportMesh node
				)
				if SuperClassOf node == Helper and ClassOf node == Point then
					ExportPoint node
			)
	
			return true
		)
		
		-------------------------------------------------------------------------------------
		function RecursiveExportNode1 node =
		(
			if (ExportNode1 node) == false then
				return false
			for child in node.children do
				RecursiveExportNode1 child
		)
	
		-------------------------------------------------------------------------------------
		function RecursiveExportNode2 node =
		(
			if (ExportNode2 node) == false then
				return false
			for child in node.children do
				RecursiveExportNode2 child
		)
	
		-------------------------------------------------------------------------------------
		function ExportSCN =
		(
			if cb_atmdefs.checked then
			(
				ATMDef.ExportATMDefs()			
			)
					
			if cb_exportSelOnly.checked then
			(
				for node in selection do
					ExportNode1 node
--				Format "FirstInit\n" to:ostream
--MC: przydatne przy eksporcie .inc
				--for node in selection do
				--	ExportNode2 node
			)
			else
			(
				clearSelection()
				for node in rootnode.children do
					RecursiveExportNode1 node
					
			if  isFileSCN==true then 
				(		
				Format "FirstInit\n" to:ostream
				)
				
			    if cb_Trainset.checked then
			    (
				    ttttrainset.ExportTrainset()			
			    )	
		
				--for node in rootnode.children do
				--RecursiveExportNode2 node		
		
			)						

			
			Print "Done";
		)
		-------------------------------------------------------------------------------------
		function GetSaveFileStream =
(	
			fname = GetSaveFileName types:"Include Files (*.inc)|*.inc|Scene Files (*.scn)|*.scn|Scene Module Files (*.scm)|*.scm|Event Files (*.ev)|*.ev|Atmo Files (*.atm)|*.atm| All Files(*.*)|*.*|"
			if fname == undefined then
				return undefined
	        
                        if getFilenameType(fname) == ".inc" then
				isFileINC = true

			if getFilenameType(fname) == ".scn" then
				isFileSCN = true

			if getFilenameType(fname) == ".scm" then
				isFileSCM = true
				
			if getFilenameType(fname) == ".ev" then
				isFileEv = true
            
			if getFilenameType(fname) == ".atm" then
				isFileATM = true

			ostream = CreateFile fname
			if ostream == undefined then
			(
				MessageBox "Couldn't open file for writing !"
				return undefined
			)
	
			return ostream
		)	
		-------------------------------------------------------------------------------------      	
	    on btn_export pressed do
		(
			ostream = GetSaveFileStream()
			if ostream != undefined then
			(
				ExportSCN()
				Close ostream
			)			
		)
	
)